# -*- coding: utf-8 -*-
# Generated by Django 1.11.4 on 2018-04-26 08:18
from __future__ import unicode_literals

from django.db import migrations


def update_submission_statuses(apps, schema_editor):
    """Update Submission incoming status to unassigned."""
    Submission = apps.get_model("submissions", "Submission")

    # Update Submission statuses
    Submission.objects.filter(status="unassigned_incoming").update(status="unassigned")
    Submission.objects.filter(status="recommendation_formulated").update(
        status="assigned"
    )
    Submission.objects.filter(status="EICassigned").update(
        status="assigned"
    )  # Renaming of key
    Submission.objects.filter(status="awaiting_ed_rec").update(status="assigned")


class Migration(migrations.Migration):
    dependencies = [
        ("submissions", "0016_auto_20180414_1825"),
    ]

    operations = [
        migrations.RunPython(update_submission_statuses),
    ]
